//PROFILE-NO
unit Profonli;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType,
//  LMessages,
//  Windows,
  Forms,
  Inifiles,
  StdCtrls,
  ComCtrls,
  SysUtils,
  Controls,
  Classes,
  ExtCtrls;
{$H-}
{$V-}
{$O-}
{$D-}
{$B-}
{$Q+}
{$I-}
{$R+}       
{$A+}
{$W-}
{$J-}
{$T+}
{$X+}
{$WARNINGS OFF}

PROCEDURE ProfOnlineOperation;
PROCEDURE ProfCloseOnlineOperation;

TYPE
  TOnlineProform = class(TForm)
    StartBut: TButton;
    StopBut: TButton;
    AddBut: TButton;
    DelBut: TButton;
    Panel1: TPanel;
    CycBut: TCheckBox;
    MinLab: TLabel;
    FrequAnz: TTrackBar;
    Minuten: TLabel;
    CycTimer: TTimer;
    Panel2: TPanel;
    RunId: TLabel;
    NextRun: TLabel;
    CommentBox: TGroupBox;
    Edit1: TEdit;
    procedure StarteMessung(Sender: TObject);
    procedure StoppeMessung(Sender: TObject);
    procedure Anhaengen(Sender: TObject);
    procedure Erzeugen(Sender: TObject);
    procedure ResultatLoeschen(Sender: TObject);
    procedure Zerstoeren(Sender: TObject);
    procedure TickChange(Sender: TObject);
    procedure ActDeact(Sender: TObject);
    procedure CycAppend(Sender: TObject);
    procedure Schliessen(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    procedure ButtonOnOff;
    PROCEDURE PositionMerken;
  public
    { Public-Deklarationen }
    IstAktiv : Boolean;
    RunNr    : Integer;
  end;

var
  OnlineProform: TOnlineProform;

CONST
{$IFDEF CPU64 }
  ProDLLMeas = 'profmeas64.so';
{$ELSE }
  ProDLLMeas = 'profmeas.so';
{$ENDIF }


FUNCTION  ProfIstAktiv : Boolean; external ProDLLMeas;
//FUNCTION  GetMHZ       : Integer; external ProDLLMeas;
PROCEDURE ProfResultatLoeschen;   external ProDLLMeas;
PROCEDURE ProfActivate;           external ProDLLMeas;
PROCEDURE ProfDeActivate;         external ProDLLMeas;
PROCEDURE ProfSetComment  ( comm   : AnsiString ); external ProDLLMeas;
PROCEDURE ProfAppendResults ( progEnd : Boolean ); external ProDLLMeas;


{$R *.lfm}

IMPLEMENTATION
USES
//  Proftime,
  Graphics;

VAR
  winxpos    : Integer;
  winypos    : Integer;
  WindowOpen : Boolean;
  Zerstoert  : Boolean;
  NoOnOpWin  : Integer;
  inifehlt   : Boolean;


PROCEDURE ProfOnlineOperation;
BEGIN
  OnlineProForm := TOnlineProForm.Create(NIL);
  IF inifehlt = FALSE THEN
    OnlineProForm.Edit1.Text := 'none'
  ELSE
    OnlineProForm.Edit1.Color := clFuchsia;
END;

PROCEDURE ProfCloseOnlineOperation;
BEGIN
  IF WindowOpen = TRUE THEN
    OnlineProform.Close;
  IF Zerstoert = FALSE THEN
    OnlineProform.Free;
END;

FUNCTION GetIniFile : String;
BEGIN
  Result := ExtractFilePath(ParamStr(0)) + 'CLProfiler.ini';
END;

procedure TOnlineProform.StarteMessung(Sender: TObject);
begin
  ProfActivate;
  ButtonOnOff;
end;

procedure TOnlineProform.StoppeMessung(Sender: TObject);
begin
  ProfDeactivate;
  ButtonOnOff;
END;

procedure TOnlineProform.Anhaengen(Sender: TObject);
VAR
  txt : Array[0..255] OF Char;
  Run : String;
BEGIN
  StrPLCopy(txt, OnlineProForm.Edit1.Text +
                 ' (Run: ' + RunId.Caption + ')', 255);
  ProfSetComment(txt);
  ProfAppendResults(FALSE);
  INC(RunNr);
  Str(RunNr, Run);
  RunId.Caption := Run;
END;

procedure TOnlineProform.Erzeugen(Sender: TObject);
BEGIN
  Zerstoert := FALSE;
  RunNr := 1;
  IF winxpos <> -1 THEN BEGIN
    Left := winxpos;
    Top  := Winypos;
  END;
  ButtonOnOff;
  WindowOpen := TRUE;
END;

procedure TOnlineProform.ButtonOnOff;
BEGIN
  IF ProfIstAktiv = TRUE THEN BEGIN
    StartBut.Enabled := FALSE;
    StopBut.Enabled := TRUE;
    END
  ELSE BEGIN
    StopBut.Enabled := FALSE;
    StartBut.Enabled := TRUE;
  END;
END;

procedure TOnlineProform.ResultatLoeschen(Sender: TObject);
BEGIN
  ProfResultatLoeschen;
END;

PROCEDURE TOnlineProform.PositionMerken;
VAR
  xps, yps : String;
  name     : String;
  Ini      : TIniFile;
BEGIN
  name := GetIniFile;
  Str(left, xps);
  Str(top, yps);
  Ini := TIniFile.Create( name );
  Ini.WriteString('PROFILER', 'SCREEN-X', xps);
  Ini.WriteString('PROFILER', 'SCREEN-Y', yps);
  Ini.UpdateFile;
  Ini.Free;
END;

procedure TOnlineProform.Zerstoeren(Sender: TObject);
BEGIN
  CycTimer.Enabled := FALSE;
  WindowOpen := FALSE;
  Zerstoert  := TRUE;
END;

PROCEDURE InitUnit;
VAR
  name    : String;
  Buffer  : String;
  anzeige : Integer;
  Ini     : TIniFile;
BEGIN
  name := GetIniFile;
  Ini    := TIniFile.Create(name);
  Buffer := Ini.ReadString('PROFILER', 'SCREEN-X', '10');
  VAL(Buffer, winxpos, anzeige);
  IF anzeige <> 0 THEN
    Winxpos := -1;
  Buffer := Ini.ReadString('PROFILER', 'SCREEN-Y', '10');
  VAL(Buffer, winypos, anzeige);
  IF anzeige <> 0 THEN
    Winypos := -1;
  Ini.Free;
  WindowOpen := FALSE;
  Zerstoert  := TRUE;
END;

procedure TOnlineProform.TickChange(Sender: TObject);
VAR
  hs : String;
begin
  CycTimer.Enabled := FALSE;
  Str(FrequAnz.Position, hs);
  MinLab.Caption := hs;
  CycTimer.Interval := FrequAnz.Position * 60000;
  IF CycBut.Checked = TRUE THEN
    CycTimer.Enabled := TRUE;
end;

procedure TOnlineProform.ActDeact(Sender: TObject);
begin
  IF CycBut.Checked = TRUE THEN BEGIN
    CycTimer.Enabled := TRUE;
    FrequAnz.Visible := FALSE;
    END
  ELSE BEGIN
    CycTimer.Enabled := FALSE;
    FrequAnz.Visible := TRUE;
  END;
end;

procedure TOnlineProform.CycAppend(Sender: TObject);
BEGIN
  Edit1.Text := DateTimeToStr(Now);
  Anhaengen(Sender);
end;

procedure TOnlineProform.Schliessen(Sender: TObject;
  var Action: TCloseAction);
begin
  CycTimer.Enabled := FALSE;
  PositionMerken;
  WindowOpen := FALSE;
end;

INITIALIZATION
  InitUnit;
FINALIZATION
  ProfCloseOnlineOperation;
END.
